# Arithmetic Quiz
# A453 Task 1/2

# Libraries for stopping program, checking file exists, random numbers
import sys
from os.path import exists
from random import randint

# Initialise variables
operator = ("+","-","*")
score = 0
names = []
position = -1
question = ""
previous = [""]

# Read list of valid student names from a file
if not exists('students.txt'):
    print("The student file is missing - please tell your teacher.")
    sys.exit("Missing File")
f = open('students.txt','r')
students = f.readlines()
f.close()

# Split name/class pairs and remove \n from class
for i in range(len(students)):
    name = (students[i].split(","))
    name[1] = int(name[1].strip())
    names.extend(name)

# Check for a valid name
while position == -1:
    name = raw_input("What is your name? ").strip().upper()
    if name in [x.upper() for x in names[::2]]:
        position = [x.upper() for x in names[::2]].index(name)
    else:
        print("Sorry - your name isn't recognised; please try again.")

name = names[position*2]
classname = names[position*2+1]

# Ask the questions
print("\nHello "+name+". I am now going to ask you ten questions. For each one, type your answer and press the Enter key.\n")
for n in range(1,11):
    # Check question not used previously and not a negative answer
    while question in previous or eval(question) < 0:
        question = str(randint(0,10))+" "+operator[randint(0,2)]+" "+str(randint(0,10))
    previous.append(question)
    answer = eval(raw_input("Qu. "+str(n)+"\tWhat is "+question.replace("*","x")+"? ")+"+0")
    if answer == eval(question):
        score += 1
        print("\tYes - well done!\n")
    else:
        print("\tSorry - the correct answer was "+str(eval(question))+".\n")

# Display the score and a comment
print("You have reached the end of the quiz.  Your score is "+str(score)+".")
if score == 10:
    print("You have scored full marks - well done!")
else:
    print("That was a good attempt - can you do better next time?")

# Read in previous scores for the class
scores = []
if exists('Class '+str(classname)+'.txt'):
    f = open('Class '+str(classname)+'.txt','r')
    old_scores = f.readlines()
    f.close()
    # Separate names and scores, remove \n characters, etc.
    for i in range(len(old_scores)):
        old_score = (old_scores[i].split(","))
        old_score[1] = int(old_score[1].strip())
        scores.extend(old_score)

# Add name and latest score to the list
scores.extend((name,score))

# Write scores to a file, ensuring a maximum of 3 per student
f = open('Class '+str(classname)+'.txt','w')
i = 0
while i < len(scores):
    if(scores.count(scores[i])) > 3:
        del scores[i:i+2]
    else:
        f.write(scores[i]+", "+str(scores[i+1])+"\n")
        i += 2
f.close()
