from random import random

# is the random point inside the quadrant?
def inside_quadrant(x,y):
  return ((x**2 + y**2)**0.5) < 1

# estimate the value of pi using the Monte
# Carlo method as shown on this page:
# https://en.wikipedia.org/wiki/Monte_Carlo_method
trials = int(input("How many iterations? "))
inside = 0
for n in range(trials):
  inside += inside_quadrant(random(),random())
print("Estimated value of pi: ",(inside/trials)*4)