from turtle import forward, right, setpos, speed, penup, pendown,color
from random import random, randint

def web(x, y, scale, col):
  penup()
  setpos(x,y)
  # random orientation
  right(randint(1,39))
  # set colour
  color(colour[col])
  pendown()
  # draw the nine radial lines
  for n in range(9):
    right(40) # exterior angle of a nonagon
    forward(200*scale)
    setpos(x,y)
  # four sets of concentric lines
  for radius in range(1,5):
    # lines are 45 pixels apart (before scaling)
    forward(45*scale)
    right(110)
    for n in range(9):
      forward(radius*31*scale) # value found by experimentation
      right(40) # exterior angle of a nonagon
    right(250)

# speed things up
speed(0)
# available colours
colour = ("#DB611E","#55354E","#144706","#318080","#404040", "#A0AB3B", "#A00F3B")
# number of webs
number = int(input("How many webs? "))
if number > 20:
  print("This may take a while!")
position = []
# check co-ordinates to reduce overlap
while len(position) < number:
  # pick random position and size
  x = randint(-300, 300)
  y = randint(-200,200)
  scale = random()*0.9 + 0.1 # not too small!
  ok = True
  for coord in position:
    # use Pythagoras to check whether they would overlap
    if ((x-coord[0])**2 + (y-coord[1])**2)**0.5 < (195*coord[2] + 195*scale):
      ok = False
      break
  if ok:
    position.append([x,y,scale])
# keep same colours apart
position.sort() 
# draw the webs, cycling through the colours
for n in range(number):
  # draw web - co-ordinates, scale (muliplier <= 1), colour
  web(position[n][0], position[n][1], position[n][2], n % len(colour))