# show the grid
def display():
  symbol = (" ","1","2","3","4","5","6","7","8","9")
  for y in range(9):
    if y % 3 == 0:
      print("-------------------------")
    row = ""
    for x in range(y*9, y*9+9):
      if x % 3 == 0:
        row += "| "
      row += symbol[grid[x]] + " "
    print(row + "|")
  print("-------------------------")

# check whether digit num is allowed at position pos
def valid(num, pos):
  allow = True
  # row and col of position pos
  col = pos % 9
  row = pos // 9
  # is num already in the same column?
  for n in range(col,81,9):
    allow = (grid[n] != num) and allow
  # is num already in the same row?
  if allow:
    for n in range(row*9,row*9+9):
      allow = (grid[n] != num) and allow
  # is num already in the 3 x 3 block?
  if allow:
    top = (row // 3)*3  # top-most row in the block
    left = (col // 3)*3 # left-most column in the block
    for m in range(top, top + 3):
      for n in range(left, left + 3):
        allow = (grid[m*9 + n] != num) and allow
  return allow

# place a next digit in the next blank square
def place_digit():
  # loop through every position in the grid
  for pos in range(81):
    # if the position is blank...
    if grid[pos] == 0:
      # ...try each digit in turn
      for n in range(1,10):
        # if the digit is a possible fit...
        if valid(n, pos):
          # ...put it in the grid
          grid[pos] = n
          # try to place the next digit
          place_digit()
          # solve returns if the next digit can't be placed, so undo the digit we just placed (i.e. "backtrack") and try the next one
          grid[pos] = 0
      return
  # the last digit has been placed, so a solution has been found
  display()
  # ...but there might be another one
  print("\nLooking for another solution...\n")
  return

# initial grid (starting top-left, across then down, 0 = blank)
# uncomment one of the puzzles or add your own
# example with two solutions:
# grid = [0,0,0,8,0,0,0,0,9,0,1,9,0,0,5,8,3,0,0,4,3,0,1,0,0,0,7,4,0,0,1,5,0,0,0,3,0,0,2,7,0,4,0,1,0,0,8,0,0,9,0,6,0,0,0,7,0,0,0,6,3,0,0,0,3,0,0,7,0,0,8,0,9,0,4,5,0,0,0,0,1]
# "Expert" Sudoku from Guardian 22/02/20
#grid = [0,0,0,0,0,5,0,0,0,0,0,2,4,8,0,3,0,0,0,0,0,7,0,9,0,2,0,0,0,0,3,6,0,4,0,5,0,0,4,0,0,1,0,6,0,1,0,0,0,0,8,2,9,0,4,0,6,0,5,0,0,8,0,3,0,0,0,0,0,0,0,0,0,1,9,6,0,0,0,0,0]
# 17-clue example from Wikipedia
grid = [0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,3,0,0,4,0,0,5,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,3,0,6,0,0,0,0,7,0,0,0,5,8,0,0,0,0,0,6,7,0,0,0,0,1,0,0,0,4,0,0,0,5,2,0,0,0,0,0,0,0]
# show the initial grid
display()
print("\nFirst solution:\n")
place_digit()
print("There are no further solutions.")